<?php // $Id: peek_summary_plugin_style.inc,v 1.1 2010/09/02 20:40:20 bec Exp $

/**
 * @see peek_summary_views_plugins().
 */
class peek_summary_plugin_style extends views_plugin_style_summary {
  function option_definition() {
    $options['count'] = array('default' => FALSE);
    $options['use_display'] = array('default' => 'default');
    $options['pager_override'] = array('default' => NULL);
    $options['use_pager'] = array('default' => TRUE);
    $options['items_per_page'] = array('default' => 4);
    return $options;
  }

  function options_form(&$form, &$form_state) {
    $form['count'] = array(
      '#type' => 'checkbox',
      '#default_value' => !empty($this->options['count']),
      '#title' => t('Display record count with link'),
    );

    $displays = array();
    $link_displays = array();
    foreach ($this->view->display as $key => $display) {
      $displays[$key] = $display->display_title;
      if (is_object($display->handler) && $display->handler->has_path()) {
        $link_displays[$key] = $display->display_title;
      }
    }

    $form['use_display'] = array(
      '#type' => 'radios',
      '#title' => t('Display to use in summary'),
      '#options' => $displays,
      '#default_value' => $this->options['use_display'],
    );

    $form['pager_override'] = array(
      '#type' => 'checkbox',
      '#default_value' => !empty($this->options['pager_override']),
      '#title' => t('Override paging'),
      '#description' => t('You may want to page summary items differently than items on the argument pages.'),
    );

    $form['use_pager'] = array(
      '#type' => 'checkbox',
      '#title' => t('Show pager'),
      '#default_value' => $this->options['use_pager'],
      '#process' => array('views_process_dependency'),
      '#dependency' => array('edit-style-options-pager-override' => array(TRUE)),
    );

    $form['items_per_page'] = array(
      '#type' => 'textfield',
      '#title' => t('Items to display'),
      '#default_value' => $this->options['items_per_page'],
      '#description' => t('The number of items to display per page. Enter 0 for no limit.'),
      '#process' => array('views_process_dependency'),
      '#dependency' => array('edit-style-options-pager-override' => array(TRUE)),
    );
  }

  function query() {
    if (!empty($this->options['pager_override'])) {
      $this->view->set_use_pager($this->options['use_pager']);
      $this->view->set_items_per_page(intval($this->options['items_per_page']));
    }
  }

  function render() {
    $argument = $this->view->argument[$this->view->build_info['summary_level']];

    $rows = array();
    foreach ($this->view->result as $row) {
      $view = $this->view->clone_view();
      $view->set_display($this->options['use_display']);
      $view->set_current_page(0);

      $args = $view->args;
      $args[$argument->position] = $argument->summary_argument($row);
      $view->set_arguments($args);

      $view->execute_display();
      $row->peek_summary_view = $view;

      $rows[] = $row;
    }

    return theme($this->theme_functions(), $this->view, $this->options, $rows);
  }
}
